
// ---

var header_spy = {

    options : null,

    // will be updated on tab change
    headers_request  : {"None" : "None"},
    headers_response : {"None" : "None"},

    get_controller: function(theDocument) {
        var controller = null;

        if (theDocument && 'defaultView' in theDocument && 'controllers' in theDocument.defaultView) {
            var controllers = theDocument.defaultView.controllers;
            while (controllers.wrappedJSObject) controllers = controllers.wrappedJSObject;
            controller = controllers.getControllerForCommand('livehttpheaders');

            // The controller might be wrapped multiple times
            while (controller && !('headers' in controller)) controller = controller.wrappedJSObject;
        }

        return controller;
    },

    get_headers_request: function(controller) {
        var headers = [];
        for (i in controller.headers.requestHeaders) {
            headers[i] = controller.headers.requestHeaders[i];
        }
        headers["REQUEST"] = controller.headers.request;
        return headers;
    },

    get_headers_response: function(controller) {
        var headers = [];
        for (i in controller.headers.responseHeaders) {
            headers[i] = controller.headers.responseHeaders[i];
        }
        //for (i in headers.responseHeaders) {
        //  // Server can send some headers multiple times...  
        //  // Try to detect this and present them in the 'good' way.
        //  var multi = headers.responseHeaders[i].split('\n');
        //  for (var o in multi) {
        //   responseheaders.addRow([i, multi[o]]);
        //  }
        //}
        headers["RESPONSE"] = controller.headers.response;
        return headers;
    },

    fetch_headers: function(headers, i, _popup_headers, v_headers, v_values) {
//        var v_headers = [];
//        var v_values = [];

        var ph_array = _popup_headers.split(' ');
        for (var ph in ph_array) {
            var header_name = ph_array[ph];
            var header_value = headers[header_name];

            if (header_name.length == 0) break;
            else if (header_value == null) {
                if (this.options.panels[i].popup_headers.show_if_exist) continue;
                else header_value = header_spy_options_store.defaults.status;
            }

            // Server can send some headers multiple times...  
            // Try to detect this and present them in the 'good' way.
            var multi = header_value.split('\n');
            for (var o in multi) {
                v_headers.push(header_name);
                v_values.push(multi[o]);
            }
        }
    },
    
    populate_tooltip_init: function(i) {
        var vbx = document.getElementById(this.options.panels[i].sbp_tooltip);
        if (vbx) {
            while (vbx.firstChild) vbx.removeChild(vbx.firstChild); // clear list
        }
        return vbx;
    },

    populate_tooltip: function(headers, i, _popup_headers, vbx, _title) {
        var v_headers = [];
        var v_values = [];
        this.fetch_headers(headers, i, _popup_headers, v_headers, v_values);

        if (0 == v_headers.length) return 0;

        // ---

        var egroupbox, evbox_names, evbox_values, ename, evalue;
        evbox_names  = document.createElement('vbox');
        evbox_values = document.createElement('vbox');

        var wrap_on = this.options.panels[i].popup_headers.wrap_on;
        for (j in v_headers) {
            var sh = v_headers[j], sv, svrest = v_values[j];
            for ( ; ; ) {
                if (wrap_on <= 0) { // don't wrap
                    sv = svrest;
                    svrest = "";
                } else {
                    sv = svrest.substring(0, wrap_on);
                    svrest = svrest.substring(wrap_on);
                }

                ename = evbox_names.appendChild(document.createElement('label'));
                ename.setAttribute('value', sh);
                ename.setAttribute('style', 'font-weight: 900;');

                evalue = evbox_values.appendChild(document.createElement('label'));
                //evalue.setAttribute('style', 'width: 500px;');
                evalue.setAttribute('crop', 'right');
                evalue.setAttribute('value', sv);

                if (0 == svrest.length) break; // no more to show
                sh = null; // don't show header on wrapped lines
            }
        }

        egroupbox = vbx.appendChild(document.createElement('groupbox'));

        evalue = egroupbox.appendChild(document.createElement('hbox'));
        evalue.appendChild(evbox_names);
        evalue.appendChild(evbox_values);

        ename = egroupbox.appendChild(document.createElement('caption'));
        ename.setAttribute('label', _title);

        return v_headers.length;
    },

    populate_menu: function(headers, i, _popup_headers, vbx, _title) {
        var v_headers = [];
        var v_values = [];
        this.fetch_headers(headers, i, _popup_headers, v_headers, v_values);

        if (0 == v_headers.length) return 0;

        // ---

        var ename, emenu, emenupopup;
        
        ename = vbx.appendChild(document.createElement("menuitem"));
        ename.setAttribute("label", _title);
        ename.setAttribute('style', 'font-weight: 900;');

        // ---
        
        //var wrap_on = this.options.panels[i].popup_headers.wrap_on;
        var wrap_on = 0; // off TODO FIXIT
        for (j in v_headers) {
            var sh = v_headers[j], sv, svrest = v_values[j];
            for ( ; ; ) {
                if (wrap_on <= 0) { // don't wrap
                    sv = svrest;
                    svrest = "";
                } else {
                    sv = svrest.substring(0, wrap_on);
                    svrest = svrest.substring(wrap_on);
                }

                emenu = vbx.appendChild(document.createElement('menu'));
                emenu.setAttribute('label', sh);
                emenu.setAttribute('tooltip', sv); // pass to submenu

                emenupopup = emenu.appendChild(document.createElement('menupopup'));
                emenupopup.addEventListener("popupshowing", header_spy.populate_menu_item, true);

/* WTF?
                ename = emenupopup.appendChild(document.createElement('menuitem'));
                //emenu.setAttribute('style', 'width: 500px;');
                //ename.setAttribute('crop', 'right');
                ename.setAttribute('label', sv);
*/

                if (0 == svrest.length) break; // no more to show
                sh = null; // don't show header on wrapped lines
            }
        }

        vbx.appendChild(document.createElement("menuseparator"));

        return v_headers.length;
    },

    populate_menu_item: function(event) {
        var emenupopup = event.target;
        while (emenupopup.firstChild) emenupopup.removeChild(emenupopup.firstChild); // clear list

        var ename = emenupopup.appendChild(document.createElement('menuitem'));
        //emenu.setAttribute('style', 'width: 500px;');
        //ename.setAttribute('crop', 'right');
        ename.setAttribute('label', emenupopup.parentNode.tooltip);
        
        event.stopPropagation();
    },
    
    rebuild: function(aWebProgress) {
        var do_clear = true;
        
        if (aWebProgress != null
                && !aWebProgress.isLoadingDocument
                && 'document' in aWebProgress
                ) {
            var controller = this.get_controller(aWebProgress.document);
            if (controller) {
                do_clear = false; // don't touch states
                this.headers_request  = this.get_headers_request(controller);
                this.headers_response = this.get_headers_response(controller);

                for (i = 0 ; i < this.options.panels.length ; i++) {
                    var value = this.options.panels[i].header;
                    value = (0 == this.options.panels[i].headersrc ? this.headers_request[value] : this.headers_response[value]);
                    this.options.panels[i].current_status = value ? value : header_spy_options_store.defaults.status;
                    // this.create_tooltip(i);
                }
            }
/*
        } else if (aWebProgress != null
                && aWebProgress.isLoadingDocument
                && 0 == this.headers_request.length
                ) {
            return; // do nothing on progress
*/
        } else {
            this.headers_request  = [];
            this.headers_response = [];
        }

        if (do_clear) { // reset states
            for (i = 0 ; i < this.options.panels.length ; i++) {
                this.options.panels[i].current_status = header_spy_options_store.defaults.status;
            }
        }

        for (i = 0 ; i < this.options.panels.length ; i++) {
            var el_status = document.getElementById(this.options.panels[i].sbp_name);
            if (!el_status) continue;

            el_status.crop = "end";
            el_status.maxWidth = this.options.panels[i].max_width;

            el_status.label = this.options.panels[i].show_name
                ? (this.options.panels[i].header + ": " + this.options.panels[i].current_status)
                : this.options.panels[i].current_status;
            el_status.collapsed = (
                this.options.panels[i].current_status == header_spy_options_store.defaults.status
                && this.options.panels[i].show_if_exist
                );
        }
    },
    	
    create_tooltip: function(i) {
        if (null == i) i = 0;

        var vbx = this.populate_tooltip_init(i);
        if (vbx) {
            var ttcnt = 0;
            if (this.options.panels[i].popup_headers.in_tooltip) {
                ttcnt += this.populate_tooltip(
                    this.headers_request,  i, this.options.panels[i].popup_headers.request
                    , vbx, "Request");
                ttcnt += this.populate_tooltip(
                    this.headers_response, i, this.options.panels[i].popup_headers.response
                    , vbx, "Response");
            }

            if (0 == ttcnt) { // there is no valid headers to show. We need to show default tooltip
                var el_status = document.getElementById(this.options.panels[i].sbp_name);
                if (el_status) {
                    var ename = document.createElement('label');
                    ename.setAttribute('value', el_status.label);
                    vbx.appendChild(ename);
                }
            }
        }
    },

    options_dialog: function() {
//        return toOpenWindowByType('global:HeaderSpyOptions', 'chrome://header_spy/content/options.xul');
        var winOptions = openDialog('chrome://header_spy/content/options.xul', 
            'HeaderSpyOptions', 
            'centerscreen,chrome,resizable=no,dialog=no');
        try {
            winOptions.focus();
        } catch (ex) {
        }
    }, 

    onclick: function(i, event) {
//        return (2 == event.button) ? this.create_menu(i) : this.full_view(i);
        if (0 == event.button) this.full_view(i); // Note: RClick - options
    },
    
    full_view: function(i) {
        if (null == i) i = 0;
        var el_status = document.getElementById(this.options.panels[i].sbp_name);

        if (el_status.maxWidth == header_spy_options_store.defaults.max_expand_width) {
            el_status.maxWidth = this.options.panels[i].max_width;
        } else {
            el_status.maxWidth = header_spy_options_store.defaults.max_expand_width;
        }
        el_status.collapsed = false;
    },

    create_menu: function(i) {
        var vbx = document.getElementById(this.options.panels[i].sbp_menu)
        if (!vbx) return;
        while (vbx.firstChild) vbx.removeChild(vbx.firstChild);
        
        // ---

        if (this.options.panels[i].popup_headers.in_menu) {
            var ttcnt;
            ttcnt += this.populate_menu(
                this.headers_request,  i,  this.options.panels[i].popup_headers.request
                , vbx, "Request");
            ttcnt += this.populate_menu(
                this.headers_response, i, this.options.panels[i].popup_headers.response
                , vbx, "Response");

            //vbx.appendChild(document.createElement("menuseparator")); 
        }

        // ---

        var mi, localeProperties = document.getElementById("header-spy-locale-properties");

        mi = document.createElement("menuitem");
        mi.setAttribute("label", localeProperties.getString("header_spy.open_pageinfo"));
        mi.setAttribute("onclick", "BrowserPageInfo(event.target.document, 'headerinfoTab')"); // "Live HTTP Headers" tab
        vbx.appendChild(mi);

        mi = document.createElement("menuitem");
        mi.setAttribute("label", localeProperties.getString("header_spy.options"));
        mi.setAttribute("onclick", "header_spy.options_dialog()");
        vbx.appendChild(mi);
    }
};

// ---

/*
eval('gBrowser.addTab =' + getBrowser().addTab.toString().replace(
    'if (!blank) {',
    'for (i = 0 ; i < header_spy.options.panels.length ; i++) { document.getElementById(header_spy.options.panels[i].sbp_name).collapsed = blank; } \
         if (!blank) {'
    )
);
*/
///*
eval('gBrowser.addTab =' + getBrowser().addTab.toString().replace(
    'if (!blank) {',
    'if (blank) header_spy.rebuild(null); if (!blank) {'
    )
);
//*/

var header_spy_prefs_observer = {
    observe: function (aSubject, aTopic, aState) 
    {
        if (aTopic == "header-spy-load-prefs") {
            header_spy.options = header_spy_options_store.get();

            for (i = 0 ; i < header_spy.options.panels.length ; i++) {
                var el_status = document.getElementById(header_spy.options.panels[i].sbp_name);
                if (!el_status) continue;
                
                el_status.crop = "end";
                el_status.maxWidth = header_spy.options.panels[i].max_width;
            }

            for ( ; ; i++) {
                var hso = header_spy_options_store.get_rec(i);
                var el_status = document.getElementById(hso.sbp_name);
                if (!el_status) break;

                el_status.collapsed = true; // collapse unused panels
            }
        }
    },
};

HEADER_SPY_OBSERV_SERVICE.addObserver(header_spy_prefs_observer,     "header-spy-load-prefs", false);
HEADER_SPY_OBSERV_SERVICE.notifyObservers(header_spy_prefs_observer, "header-spy-load-prefs", false);

// ---

const STATE_START = Components.interfaces.nsIWebProgressListener.STATE_START;
const STATE_STOP  = Components.interfaces.nsIWebProgressListener.STATE_STOP;

function header_spy_register_ASL()
{
    header_adv_status_listener.init();
    window.getBrowser().addProgressListener(header_adv_status_listener, STATE_START);
}

function header_spy_unregister_ASL()
{
    header_adv_status_listener.destroy();
    window.getBrowser().removeProgressListener(header_adv_status_listener, STATE_STOP);
}


window.addEventListener("load", header_spy_register_ASL,false);
window.addEventListener("unload", header_spy_unregister_ASL,false);

var header_adv_status_listener =
{
    QueryInterface: function(aIID) {
      if (aIID.equals(Components.interfaces.nsIWebProgressListener) ||
          aIID.equals(Components.interfaces.nsISupportsWeakReference) ||
          aIID.equals(Components.interfaces.nsIXULBrowserWindow) ||
          aIID.equals(Components.interfaces.nsISupports) ||
          aIID.equals(Components.interfaces.nsIHttpNotify) ||
          aIID.equals(Components.interfaces.nsIObserver))
        return this;
      throw Components.results.NS_NOINTERFACE;
    },
  
    init: function() {
    },
  
    destroy: function() {
    },
  
    onStateChange: function(aWebProgress, aRequest, aStateFlags, aStatus) {
        if (aStateFlags & STATE_START) {
            // this.el_status.crop = "end";
            // this.el_status.maxWidth = header_spy_maxWidths;
        } else if (aStateFlags & STATE_STOP) {
            header_spy.rebuild(aWebProgress);
        }
    },
  
    onProgressChange: function (a, b, c, d, e, f) {
    },
    
    onLocationChange: function(a, b, c) {
        header_spy.rebuild(a);
        window.XULBrowserWindow.onLocationChange(a, b, c);
    },

    onStatusChange: function(a, b, c, d) {
    },
    onSecurityChange: function(a, b, c) {
    },
    onLinkIconAvailable: function(a) {
    }
};

